<script setup lang="ts">
import CustomSelect from './CustomSelect.vue';
import BaseInput from './BaseInput.vue';
import { useRouter, useRoute } from 'vue-router'
import { useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { ref, watch, computed } from 'vue'
const props = defineProps({
  options: Object,
})
const episodesList = ref(false);
const episodesListHold = ref(false);
const page = ref(1);
const router = useRouter()
const route = useRoute()
const selected = ref(Object.keys(Object(props.options))[0]);
const content = ref(String(route.query.s ?? ''));

watch(() => route.query, () => {
  selected.value = String(route.query.c ?? Object.keys(Object(props.options))[0]);
  content.value = selected.value === 'episode' ? content.value : String(route.query.s ?? '');
  episodesList.value = false;
});

watch(() => selected.value, () => {
  if(selected.value !== 'episode'){
    episodesList.value = false;
  }
})

watch(() => content.value, () => {
  if( content.value.length >= 3 && selected.value === 'episode'){
    episodesList.value = true;
  }else{
    episodesList.value = false;
  }
})

const searchObj = computed(() => selected.value === 'episode' ? { [selected.value]: content.value } : {});

const variables = computed(() => selected.value === 'episode' ? {
  page: page.value ?? 1,
  search: searchObj.value
} : {})

const GET_EPISODES = gql`
  query getEpisodes($page: Int, $search: FilterEpisode) {
    episodes(page: $page, filter: $search) {
      info {
        count,
        pages,
        next,
        prev
      }
      results {
        name,
        episode,
        id
      }
    }
  }
`;

const { result, loading, error } = useQuery( GET_EPISODES, variables )

const episodes = computed(() => result?.value?.episodes?.results ?? [] )

function updatePage(){
  if(selected.value!=='episode'){
    router.push({ path: '/', query: { c: selected.value, s: content.value } });
  }
}
</script>

<template>
  <div class="search-bar">
    <div class="searchLabel"><p>Search by</p></div>
    <CustomSelect :options="Object(props.options)" v-model="selected" />
    <BaseInput v-model="content" class="searchInput" @search="updatePage" @keyup.enter="updatePage" @focusin="if (content.length >= 3) { episodesList = true; }" @focusout="if ( !episodesListHold ) { episodesList = false; }" />
    <div v-if="episodes && episodesList"  class="episodes-list" @mouseover="episodesListHold = true" @mouseout="episodesListHold = false">
      <div v-for="(episode) of episodes" :key="episode.id">
        <div @click="episodesListHold = false, content = episode.episode + ' - ' + episode.name, router.push({ path: '/', query: { c: 'episode', s: episode.id } })">{{episode.episode}} - {{episode.name}}</div>
      </div>
    </div>
    <div v-else-if="loading && episodesList"  class="episodes-list"><div><div>Loading...</div></div></div>
    <div v-else-if="error && episodesList"  class="episodes-list"><div><div>An error occurred while loading. Try again later</div></div></div>
    <div v-if="!episodes || episodes.length < 1 && episodesList"  class="episodes-list"><div><div>No results</div></div></div>
  </div>
  
</template>

<style scoped>
.search-bar {
  max-width: 505px;
  width:100%;
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  align-content: center;
  align-items: center;
  border: 1px solid #A9B1BD;
  border-radius: 12px;
  display: flex;
}
/*.search-bar > div:not(:first-child):before {
  content: "";
  border: 0.5px solid #d3d3d3;
  align-self: stretch;
  position: absolute;
  height:100%;
}*/
.searchInput{
  width:50%;
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  align-content: center;
  align-items: center;
  padding-right: 1rem;
}
.searchLabel{
  pointer-events: none;
  text-align: center;
  width:25%;
}
.episodes-list {
  position: absolute;
  top: 100%;
  right: 0;
  width: 252px;
  z-index:100;
  }
.episodes-list > div {
  border: 0.5px solid #A9B1BD;
  background-color: var(--color-background);
  padding: 0 1rem;
}
.episodes-list > div:hover{
  color:#fff;
  background-color: #11B0C8;
  cursor: pointer;
}
.episodes-list > div > div {
  line-height: 47px;
}
.episodes-list > div:first-child{
  border-radius:0 12px 0 0;
}
.episodes-list > div:last-child{
  border-radius:0 0 12px 12px;
}
</style>
